\name{nativeStorageMethods-class}
\docType{class}
\alias{nativeStorageMethods-class}
\alias{allocatedSize,nativeStorageMethods-method}
\alias{allocator,nativeStorageMethods-method}
\alias{getPointer,nativeStorageMethods-method}
\alias{initializeResource,nativeStorageMethods-method}

\title{Class "nativeStorageMethods", class holding an external pointer
  to a C storeageMethods structure. }
\description{ This simple class has only one purpose - holding an
  external pointer that contains a pointer to a C
  \code{storageMethods} structure. The memory for the C structure is
  allocated by the "gcAllocator" memory allocator. }
\section{Objects from the Class}{
  Objects can be created by calls of the form
  \code{new("nativeStorageMethods", \dots)}. For details on how the
  \code{\dots} argument to \code{new} works, see documentation for the
  \code{"initialize"} method for class \code{"externalResource"}.
  
  The \code{ptr} slot in a newly created object contains
  pointer to an uninitialized C \code{storageMethods} structure.
}
\section{Slots}{
  \describe{
    \item{\code{ptr}:}{Object of class \code{"externalptr"} }
  }
}
\section{Extends}{
Class \code{"externalResource"}, directly.
}
\section{Methods}{
  Signature components of the methods:

  \tabular{ll}{
    resource \tab The class "nativeStorageMethods"\cr
    ptr \tab The class "externalptr"\cr
    size \tab The class "ANY"\cr
    type \tab The class "ANY"\cr
  }

  Description of the methods:

  \describe{
    \item{allocatedSize(resource):}{ Returns the size of the C
      \code{storageMethods} structure in bytes. }
    \item{allocator(resource):}{ Returns an object of class
      \code{"gcAllocator"}. }
    \item{getPointer(reource):}{ Return the \code{ptr} slot. }
    \item{initializeResource(resource, ptr, size, type, \dots):}{
      Sets the \code{ptr} }
  }
}
\seealso{
  \code{\link{nativeStorageMethodsList-class}}
  for how this class is used.
  
  \code{\link{externalResource-class}} for more on the super class of
  this class.
}
\keyword{classes}
\keyword{methods}
